/*******************************************************************************
 * Copyright (c) 2025, Jan Koester jan.koester@gmx.net
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 * Neither the name of the <organization> nor the
 *      names of its contributors may be used to endorse or promote products
 *      derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *******************************************************************************/

#include <cstring>
#include <iostream>

#include <cmdplus/cmdplus.h>
#include <httppp/http.h>

#include "client.h"

void addclient(int argc,char **argv){
    cmdplus::CmdController &cmdc=cmdplus::CmdController::getInstance();

    cmdc.registerCmd("name",'n',true,"","Client Name");
    cmdc.registerCmd("secret",'s',true,"","Client Secret");
    cmdc.registerCmd("host-url",'h',true,"","Server Url");

    cmdc.registerCmd("username",'u',true,"","Username");
    cmdc.registerCmd("password",'p',true,"","Password for User");

    cmdc.parseCmd(argc,argv);

    if(!cmdc.checkRequired()){
        cmdc.printHelp();
        return;
    }

    authdb::client::ClientConnection con;

    con.setUrl(cmdc.getCmdbyKey("host-url")->getValue());
    con.setUsername(cmdc.getCmdbyKey("username")->getValue());
    con.setUserPassword(cmdc.getCmdbyKey("password")->getValue());

    authdb::client::Client clt(con);
    if(clt.UserAuth())
        clt.addConnection(cmdc.getCmdbyKey("name")->getValue(),cmdc.getCmdbyKey("secret")->getValue());

}

void remclient(int argc,char **argv){
    cmdplus::CmdController &cmdc=cmdplus::CmdController::getInstance();

    cmdc.registerCmd("name",'n',false,"","Client Name");
    cmdc.registerCmd("secret",'s',false,"","Client Secret");

    cmdc.registerCmd("host-url",'h',true,"","Server Url");

    cmdc.registerCmd("clientid",'i',true,"","Clientid");

    cmdc.registerCmd("username",'u',true,"","Username");
    cmdc.registerCmd("password",'p',true,"","Password for User");

    cmdc.parseCmd(argc,argv);

    if(!cmdc.checkRequired()){
        cmdc.printHelp();
        return;
    }

    authdb::client::ClientConnection con;

    con.setUrl(cmdc.getCmdbyKey("host-url")->getValue());
    con.setUsername(cmdc.getCmdbyKey("username")->getValue());
    con.setUserPassword(cmdc.getCmdbyKey("password")->getValue());

    authdb::client::Client clt(con);
    if(clt.UserAuth())
        clt.remConnection(cmdc.getCmdbyKey("clientid")->getValue());

}

void editclient(int argc,char **argv){
    cmdplus::CmdController &cmdc=cmdplus::CmdController::getInstance();

    cmdc.registerCmd("name",'n',true,"","Client Name");
    cmdc.registerCmd("secret",'s',true,"","Client Secret");
    cmdc.registerCmd("host-url",'h',true,"","Server Url");
    cmdc.registerCmd("clientid",'i',true,"","Clientid");

    cmdc.registerCmd("username",'u',true,"","Username");
    cmdc.registerCmd("password",'p',true,"","Password for User");

    cmdc.parseCmd(argc,argv);

    if(!cmdc.checkRequired()){
        cmdc.printHelp();
        return;
    }

    authdb::client::ClientConnection con;

    con.setUrl(cmdc.getCmdbyKey("host-url")->getValue());
    con.setUsername(cmdc.getCmdbyKey("username")->getValue());
    con.setUserPassword(cmdc.getCmdbyKey("password")->getValue());

    authdb::client::Client clt(con);
    if(clt.UserAuth()){
        clt.editConnection(
            cmdc.getCmdbyKey("clientid")->getValue(),
            cmdc.getCmdbyKey("name")->getValue(),
            cmdc.getCmdbyKey("secret")->getValue()
        );
    }

}

void gpoexists(int argc,char **argv){
    cmdplus::CmdController &cmdc=cmdplus::CmdController::getInstance();

    cmdc.registerCmd("name",'n',true,"","Client Name");
    cmdc.registerCmd("secret",'s',true,"","Client Secret");
    cmdc.registerCmd("host-url",'h',true,"","Server Url");
    cmdc.registerCmd("gpoid",'g',true,"","GPO Id");

    cmdc.parseCmd(argc,argv);

    if(!cmdc.checkRequired()){
        cmdc.printHelp();
        return;
    }

    authdb::client::ClientConnection con;

    con.setUrl(cmdc.getCmdbyKey("host-url")->getValue());
    con.setClientName(cmdc.getCmdbyKey("name")->getValue());
    con.setClientSecret(cmdc.getCmdbyKey("secret")->getValue());

    authdb::client::Client clt(con);
    if(clt.ClientAuth()){
        if(clt.GPOexits(
            cmdc.getCmdbyKey("gpoid")->getValue()
        )){
            std::cout << "true" << std::endl;
        }else{
            std::cout << "false" << std::endl;
        }
    }

}

int main(int argc,char **argv){
    if(argc<2){
        std::cerr << "Please Enter Command !" << std::endl;
    }

    if(strcmp(argv[1],"addclient")==0){
        addclient(argc-1,argv+1);
    }else if(strcmp(argv[1],"remclient")==0){
        remclient(argc-1,argv+1);
    }else if(strcmp(argv[1],"editclient")==0){
        editclient(argc-1,argv+1);
    }else if(strcmp(argv[1],"gpoexists")==0){
        gpoexists(argc-1,argv+1);
    }else{
        std::cerr << "commands:" << std::endl;
        std::cerr << "addclient" << std::endl;
        std::cerr << "remclient" << std::endl;
        std::cerr << "editclient" << std::endl;
        std::cerr << "gpoexists" << std::endl;
    }


}
